import java.io.*;
import java.util.*;

public class Students {
   
 static int MaxSize=10 ;

static char GetChoice(String OK)  throws java.io.IOException
{char Reply;
 
 do {
  Reply=Character.toUpperCase((char)System.in.read());
 } while (OK.indexOf(Reply,0)==-1);
 System.in.read();
 return(Reply);
}

static void GetValues(Student[] List,IntegerObject ListSize)
                                             throws java.io.IOException
{
  String Name;
  int Points,Hours ;
  File InputFile=new File("Students.dat");
  // Now, open a stream from the input file
  DataInputStream DataInput=new DataInputStream(new FileInputStream(InputFile));
  String Line;
  while (ListSize.GetValue()<MaxSize &&(Line=DataInput.readLine())!=null) {
     StringTokenizer Parse=new StringTokenizer(Line);
     Name=Parse.nextToken();
     Hours=Integer.valueOf(Parse.nextToken()).intValue();
     Points=Integer.valueOf(Parse.nextToken()).intValue();
  
     List[ListSize.GetValue()]=new Student(Name,Hours,Points);
     ListSize.Increment(1);
  }
} 
                           
 // Print Student Header
 static void PrintStudentHeader() throws java.io.IOException
 {
    System.out.println("Sorted list of Students\n");
    System.out.println("\nStudent Name        Hours      GPA\n");
 }

static void SortValues(Student[] List,IntegerObject ListSize)
{ //System.out.println("SORTING");
  for  (int i=0;i < ListSize.GetValue() ;i++)
  {
    int j=i;
    String s =List[i].GetName();
    Student temp=List[i];    
    while (( j>0) && (Student.CompareNames(List[j-1],temp) > 0))
    {       
           List[j]=List[j-1];
	   j--;
    }
    List[j]=temp;
  }       
//System.out.println("DONE");
}


static void SearchValues(Student[] List,IntegerObject ListSize,String str,
                           IntegerObject Position )
{ 
  int i=-1;
  int j = ListSize.GetValue();
  int k=0;
  Student temp = new Student(str);
  boolean matchName = false;
    while ( (i+1<j)&& (!matchName) )
    {
     k=(i+j)/2;
     if ((result=Student.CompareNames(List[k],temp)==0)
       matchName = true;
     else if (result < 0)
        i=k;
     else 
        j = k;
    }
    
    
    if (matchName)
       Position.SetValue(k);
    else
       Position.SetValue(-1); 
       
}


static void ReportValues(Student[] List,IntegerObject ListSize)
                                             throws java.io.IOException
{ PrintStudentHeader();                                            
  for  (int i=0;i < ListSize.GetValue() ;i++)
     Student.PrintStudentInfo(List[i]);
}   

static void FailedSearch() throws java.io.IOException
{ 
  System.out.println(" No such Student Info Found in database ");
} 

static void SuccessSearch(Student [] List,IntegerObject Position) throws java.io.IOException
{ 
  System.out.println(" Student Info Requested from database :");
  List[Position.GetValue()].PrintStudentInfo();
} 

      
public static void main(String[] args) throws java.io.IOException
{
 char Choice;
 String str ;
 Student[] StudentList = new Student[MaxSize];
 IntegerObject NumberOfValues=new IntegerObject(),
               Position = new IntegerObject();
 DataInputStream DataInput=new DataInputStream(System.in);
 
 GetValues(StudentList,NumberOfValues);
 SortValues(StudentList,NumberOfValues);
 ReportValues(StudentList,NumberOfValues);

 while ( true ) 
 {   
     System.out.println(" Info Requested for Student:\n");
     System.out.print(" Name>");
     System.out.flush();
     str = DataInput.readLine();
     if (str.equals(".")) break;
     
     SearchValues(StudentList,NumberOfValues,str,Position);
     if (Position.GetValue() < 0)
         FailedSearch();
     else
        SuccessSearch(StudentList,Position);
 }

} // end of main()


} // end class

